import sys
import csv
import json
from subprocess import Popen,PIPE

total = len(sys.argv)
script_name = str(sys.argv[0])
cdc_start_stop = str(sys.argv[1])

if cdc_start_stop not in ('start', 'stop'):
    print ('Enter valid DMS Task activity value : start / stop')
    exit()
if cdc_start_stop == 'start' and total != 3:
   print ('Script usage: python', script_name, 'start', 'cdc_start_time')
   exit ()
if cdc_start_stop == 'stop' and total != 2:
   print ('Script usage: python', script_name, 'stop')
   exit ()
if cdc_start_stop == 'start':
    cdc_start_time = str(sys.argv[2])
else:
    cdc_start_time = ''
#print (cdc_start_stop)
#print (cdc_start_time)

filename = "dms-cft-input.csv"
tasklist = []

with open(filename, "r") as csv_file:
    csv_reader = csv.DictReader(csv_file, delimiter=',')

    for lines in csv_reader:
        taskname = lines['taskName'].lower().replace('_','')
        #print taskname
        if (taskname not in tasklist):
            tasklist.append(taskname)
    #print tasklist
    for uniqtask in tasklist:
        print ('Task Name - ' + uniqtask)
        cmd = 'aws dms describe-replication-tasks --filters "Name= replication-task-id,Values='+uniqtask+'" --query "ReplicationTasks[0].[ReplicationTaskArn]" --output json'
        process = Popen(cmd, stdout=PIPE, stderr=PIPE, shell=True)
        response, error = process.communicate()
        print(response)
        task_arn = (response[response.find('"') + len('"'):response.rfind('"')])
        print ('task_arn - ' + task_arn)

        cmd = 'aws dms describe-replication-tasks --filters "Name= replication-task-id,Values='+uniqtask+'" --query "ReplicationTasks[0].Status" --output json'
        process = Popen(cmd, stdout=PIPE, stderr=PIPE, shell=True)
        response, error = process.communicate()
        #print(response)
        response = str(response)
        task_arn_status = (response[response.find('"') + len('"'):response.rfind('"')])
        print ('task_arn_status - ' + task_arn_status)

        cmd = 'aws dms describe-replication-tasks --filters "Name= replication-task-id,Values='+uniqtask+'" --query "ReplicationTasks[0].MigrationType" --output json'
        process = Popen(cmd, stdout=PIPE, stderr=PIPE, shell=True)
        response, error = process.communicate()
        #print(response)
        response = str(response)
        task_migration_type = (response[response.find('"') + len('"'):response.rfind('"')])
        print ('task_migration_type - ' + task_migration_type)

        if (cdc_start_stop == 'start') and (task_arn_status == 'ready'):
            print('Starting ' + task_migration_type + ' task for ' + uniqtask)
            if task_migration_type == 'full-load':
                cmd = 'aws dms start-replication-task --replication-task-arn ' + task_arn + ' --start-replication-task-type start-replication '
            else:
                cmd = 'aws dms start-replication-task --replication-task-arn ' + task_arn + ' --start-replication-task-type start-replication --cdc-start-time ' + cdc_start_time
            print (cmd)
            process = Popen(cmd, stdout=PIPE, stderr=PIPE, shell=True)
            response, error = process.communicate()
            #print(response)
            #print(error)
            response = str(response)
            print(response)

        if (cdc_start_stop == 'stop') and (task_arn_status != 'ready'):
            print('Stopping ' + task_migration_type + ' task for ' + uniqtask)
            cmd = 'aws dms stop-replication-task --replication-task-arn ' + task_arn
            print (cmd)
            process = Popen(cmd, stdout=PIPE, stderr=PIPE, shell=True)
            response, error = process.communicate()
            #print(response)
            #print(error)
            response = str(response)
            print(response)

        if (cdc_start_stop == 'start') and (task_arn_status != 'ready'):
            print(task_migration_type + ' task ' + uniqtask + ' is not in ready status')

        if (cdc_start_stop == 'stop') and (task_arn_status == 'ready'):
            print(task_migration_type + ' task ' + uniqtask + ' is not in running status')
