-- ------------ Write CREATE-TYPE-stage scripts -----------

CREATE TYPE orcl.migr_filter AS (
filter_type NUMERIC(38),
objtype CHARACTER VARYING(40),
objectids orcl.objectidlist,
names orcl.namelist,
whereclause CHARACTER VARYING(1000)
);



CREATE TYPE orcl.migr_report_detail_row AS (
captured_id NUMERIC(38,0),
captured_name CHARACTER VARYING(4000),
converted_name CHARACTER VARYING(4000),
captured_type CHARACTER VARYING(4000),
converted_type CHARACTER VARYING(4000),
capture_status CHARACTER VARYING(20),
convert_status CHARACTER VARYING(20),
generate_status CHARACTER VARYING(20),
logtext CHARACTER VARYING(4000)
);



CREATE TYPE orcl.migr_report_sum_row AS (
label CHARACTER VARYING(50),
schema_sum DOUBLE PRECISION,
table_sum DOUBLE PRECISION,
index_sum DOUBLE PRECISION,
constraint_sum DOUBLE PRECISION,
view_sum DOUBLE PRECISION,
trigger_sum DOUBLE PRECISION,
sp_sum DOUBLE PRECISION
);



CREATE TYPE orcl.my_pkg$pkg_type$c AS (
column_value NUMERIC(38)
);



CREATE TYPE orcl.name_and_count_t AS (
object_name CHARACTER VARYING(30),
update_count NUMERIC(38)
);



CREATE TYPE orcl.namelist$c AS (
column_value CHARACTER VARYING(40)
);



CREATE TYPE orcl.numarray$c AS (
column_value NUMERIC(38)
);



CREATE TYPE orcl.objectidlist$c AS (
column_value NUMERIC(38)
);



CREATE TYPE orcl.strings_t$c AS (
column_value CHARACTER VARYING(100)
);



CREATE TYPE orcl.tableau_views$t_allegations_rec AS (
allegation_id DOUBLE PRECISION,
period_id DOUBLE PRECISION,
disclosure_id CHARACTER VARYING(20),
case_number CHARACTER VARYING(20),
issue CHARACTER VARYING(2000),
merge_job_id DOUBLE PRECISION,
country CHARACTER VARYING(40),
therapeutic_area_code CHARACTER VARYING(25),
allegation_type CHARACTER VARYING(2000),
allegation_subtype CHARACTER VARYING(2000),
allegation_nature CHARACTER VARYING(2000),
subject CHARACTER VARYING(2000),
disclosure_details CHARACTER VARYING(2000),
reported_by CHARACTER VARYING(2000),
incident_date TIMESTAMP(0) WITHOUT TIME ZONE,
reported_date TIMESTAMP(0) WITHOUT TIME ZONE,
opened_date TIMESTAMP(0) WITHOUT TIME ZONE,
disclosure_action CHARACTER VARYING(2000),
case_action CHARACTER VARYING(2000),
followup_action CHARACTER VARYING(1000),
created_date TIMESTAMP(0) WITHOUT TIME ZONE
);



CREATE TYPE orcl.tableau_views$t_audit_findings_rec AS (
finding_id DOUBLE PRECISION,
quarter DOUBLE PRECISION,
year CHARACTER VARYING(4),
country_code CHARACTER VARYING(2),
entity CHARACTER VARYING(250),
report_number CHARACTER VARYING(25),
report_name CHARACTER VARYING(500),
report_date TIMESTAMP(0) WITHOUT TIME ZONE,
item_number CHARACTER VARYING(25),
issue CHARACTER VARYING(2000),
issue_type_code CHARACTER VARYING(5),
details CHARACTER VARYING(2000),
action CHARACTER VARYING(2000),
responsible_party CHARACTER VARYING(2000),
target_date TIMESTAMP(0) WITHOUT TIME ZONE,
status CHARACTER VARYING(25),
sox_location CHARACTER VARYING(100),
source_id DOUBLE PRECISION,
ics_number CHARACTER VARYING(25),
import_id DOUBLE PRECISION
);



CREATE TYPE orcl.tableau_views$t_comm_mtg_action_item_rec AS (
meeting_id DOUBLE PRECISION,
meeting_title CHARACTER VARYING(250),
quarter DOUBLE PRECISION,
year CHARACTER VARYING(4),
meeting_date TIMESTAMP(0) WITHOUT TIME ZONE,
country_code CHARACTER VARYING(2),
country_name CHARACTER VARYING(50),
item_number DOUBLE PRECISION,
category CHARACTER VARYING(100),
title CHARACTER VARYING(250),
description CHARACTER VARYING(4000),
timeline CHARACTER VARYING(50),
status CHARACTER VARYING(25),
recommendation CHARACTER VARYING(1000)
);



CREATE TYPE orcl.tableau_views$t_investigations_rec AS (
investigation_id DOUBLE PRECISION,
period_id DOUBLE PRECISION,
merge_job_id DOUBLE PRECISION,
case_number CHARACTER VARYING(15),
rise_investigation_number CHARACTER VARYING(15),
brand CHARACTER VARYING(50),
therapeutic_area CHARACTER VARYING(50),
country CHARACTER VARYING(50),
primary_issue CHARACTER VARYING(2000),
secondary_issue_1 CHARACTER VARYING(2000),
secondary_issue_2 CHARACTER VARYING(2000),
allegation_type CHARACTER VARYING(2000),
allegation_subtype CHARACTER VARYING(2000),
allegation_summary CHARACTER VARYING(2000),
status CHARACTER VARYING(10),
investigator CHARACTER VARYING(100),
action CHARACTER VARYING(2000),
incident_date TIMESTAMP(0) WITHOUT TIME ZONE,
received_date TIMESTAMP(0) WITHOUT TIME ZONE,
opened_date TIMESTAMP(0) WITHOUT TIME ZONE,
closed_date TIMESTAMP(0) WITHOUT TIME ZONE,
completion_date TIMESTAMP(0) WITHOUT TIME ZONE,
primary_outcome CHARACTER VARYING(2000),
secondary_outcome_1 CHARACTER VARYING(2000),
secondary_outcome_2 CHARACTER VARYING(2000),
participant_summary CHARACTER VARYING(2000),
created_date TIMESTAMP(0) WITHOUT TIME ZONE
);



CREATE TYPE orcl.tableau_views$t_observations_rec AS (
observation_id DOUBLE PRECISION,
period_id DOUBLE PRECISION,
merge_job_id DOUBLE PRECISION,
source_type CHARACTER VARYING(20),
source_id CHARACTER VARYING(25),
case_number CHARACTER VARYING(15),
country CHARACTER VARYING(50),
brand CHARACTER VARYING(50),
therapeutic_area CHARACTER VARYING(50),
observation CHARACTER VARYING(2000),
allegation_type CHARACTER VARYING(2000),
allegation_subtype CHARACTER VARYING(2000),
observation_date TIMESTAMP(0) WITHOUT TIME ZONE,
action CHARACTER VARYING(2000),
action_date TIMESTAMP(0) WITHOUT TIME ZONE,
created_date TIMESTAMP(0) WITHOUT TIME ZONE
);



CREATE TYPE orcl.type1 AS (
a NUMERIC(38),
b NUMERIC(38)
);



CREATE TYPE orcl.type11 AS (
a NUMERIC(38),
b NUMERIC(38)
);



