-- ------------ Write CREATE-CONSTRAINT-stage scripts -----------

ALTER DOMAIN orcl.name_and_count_array
ADD CONSTRAINT name_and_count_array_limit_1 CHECK (ARRAY_LENGTH(VALUE, 1) <= 30);



ALTER DOMAIN orcl.numarray
ADD CONSTRAINT numarray_limit_1 CHECK (ARRAY_LENGTH(VALUE, 1) <= 5);



ALTER TABLE orcl.account
ADD CONSTRAINT account_pk PRIMARY KEY (accountid);



ALTER TABLE orcl.allegation_type_transfm_rules
ADD CONSTRAINT pk_allegation_tp_trasnfm_rules PRIMARY KEY (import_type_code, key);



ALTER TABLE orcl.allegations
ADD CONSTRAINT pk_allegations PRIMARY KEY (allegation_id);



ALTER TABLE orcl.allegations_dummy
ADD CONSTRAINT pk_allegations_dummy PRIMARY KEY (allegation_id);



ALTER TABLE orcl.audit_finding_issue_types
ADD CONSTRAINT pk_csoar_issue_types PRIMARY KEY (issue_type_code);



ALTER TABLE orcl.audit_finding_sources
ADD CONSTRAINT pk_audit_finding_sources PRIMARY KEY (source_id);



ALTER TABLE orcl.audit_finding_sox_locations
ADD CONSTRAINT pk_audit_finding_sox_locations PRIMARY KEY (sox_location_id);



ALTER TABLE orcl.audit_findings
ADD CONSTRAINT pk_audit_findings PRIMARY KEY (finding_id);



ALTER TABLE orcl.audit_log
ADD CONSTRAINT pk_audit_log PRIMARY KEY (audit_log_id);



ALTER TABLE orcl.bmsmemberof_groups
ADD CONSTRAINT pk_bmsmemberof_id PRIMARY KEY (bmsid, bmsmemberof);



ALTER TABLE orcl.brand_aliases
ADD CONSTRAINT pk_brand_aliases PRIMARY KEY (brand_alias_id);



ALTER TABLE orcl.brands
ADD CONSTRAINT pk_brands PRIMARY KEY (brand_id);



ALTER TABLE orcl.broker
ADD CONSTRAINT broker_pk PRIMARY KEY (brokerid);



ALTER TABLE orcl.broker_asset
ADD CONSTRAINT broker_asset_ck1 CHECK (resolved_status_cd IN ('Y', 'N', 'P'));



ALTER TABLE orcl.broker_asset
ADD CONSTRAINT broker_asset_ck2 CHECK (map_to_security_cd IN ('Y', 'N'));



ALTER TABLE orcl.broker_asset
ADD CONSTRAINT broker_asset_pk PRIMARY KEY (broker_asset_id);



ALTER TABLE orcl.broker_asset
ADD CONSTRAINT broker_asset_uk UNIQUE (brkr_asset_idntfr_type_list, brkr_asset_idntfr_val_list, broker_parent_id);



ALTER TABLE orcl.broker_parent
ADD CONSTRAINT broker_parent_ck2 CHECK (broker_type IN ('STANDARD', 'DEMO', 'TEST'));



ALTER TABLE orcl.broker_parent
ADD PRIMARY KEY (broker_parent_id);



ALTER TABLE orcl.brokeraccount_lookup
ADD CONSTRAINT brokeraccount_lookup_pk PRIMARY KEY (accountid, brokeraccount);



ALTER TABLE orcl.cases
ADD CONSTRAINT pk_cases PRIMARY KEY (case_number);



ALTER TABLE orcl.client
ADD CONSTRAINT client_ck1 CHECK (client_type IN ('STANDARD', 'DEMO', 'TEST'));



ALTER TABLE orcl.client
ADD CONSTRAINT client_uk UNIQUE (clientname);



ALTER TABLE orcl.client
ADD PRIMARY KEY (clientid);



ALTER TABLE orcl.committee_meeting_action_items
ADD CONSTRAINT pk_committee_mtg_action_items PRIMARY KEY (action_item_id);



ALTER TABLE orcl.committee_meetings
ADD CONSTRAINT pk_committee_meetings PRIMARY KEY (meeting_id);



ALTER TABLE orcl.countries
ADD CONSTRAINT pk_countries PRIMARY KEY (country_code);



ALTER TABLE orcl.country_aliases
ADD CONSTRAINT pk_country_aliases PRIMARY KEY (country_alias_id);



ALTER TABLE orcl.country_hierarchy_nodes
ADD CONSTRAINT pk_country_hierarchy_nodes PRIMARY KEY (node_id);



ALTER TABLE orcl.cpi
ADD CONSTRAINT pk_cpi PRIMARY KEY (wb_country_code, year);



ALTER TABLE orcl.databasechangeloglock
ADD CONSTRAINT pk_databasechangeloglock PRIMARY KEY (id);



ALTER TABLE orcl.department
ADD CONSTRAINT department_pk PRIMARY KEY (department_id);



ALTER TABLE orcl.departments
ADD CONSTRAINT dept_id_pk PRIMARY KEY (department_id);



ALTER TABLE orcl.dim_person
ADD CONSTRAINT dim_person_pk PRIMARY KEY (person_id);



ALTER TABLE orcl.disabled_account
ADD CONSTRAINT disabled_account_pk PRIMARY KEY (account_id);



ALTER TABLE orcl.disclosures
ADD CONSTRAINT pk_disclosures PRIMARY KEY (disclosure_id);



ALTER TABLE orcl.distributors
ADD CONSTRAINT pk_distributors PRIMARY KEY (distributor_id);



ALTER TABLE orcl.domains
ADD CONSTRAINT pk_domains PRIMARY KEY (domain_code);



ALTER TABLE orcl.employee
ADD CONSTRAINT employee_pk PRIMARY KEY (employee_id);



ALTER TABLE orcl.employees
ADD CONSTRAINT emp_emp_id_pk PRIMARY KEY (employee_id);



ALTER TABLE orcl.entity_type
ADD CONSTRAINT entity_type_pk PRIMARY KEY (entitytypeid);



ALTER TABLE orcl.events
ADD CONSTRAINT pk_events PRIMARY KEY (event_id);



ALTER TABLE orcl.import_types
ADD CONSTRAINT pk_import_types PRIMARY KEY (import_type_code);



ALTER TABLE orcl.imports
ADD CONSTRAINT pk_imports PRIMARY KEY (import_id);



ALTER TABLE orcl.invalid_aliases
ADD CONSTRAINT pk_invalid_aliases PRIMARY KEY (invalid_alias_id);



ALTER TABLE orcl.investigations
ADD CONSTRAINT pk_investigations PRIMARY KEY (investigation_id);



ALTER TABLE orcl.investigations_dummy
ADD CONSTRAINT pk_investigations_dummy PRIMARY KEY (investigation_id);



ALTER TABLE orcl.liquibase_emp
ADD CONSTRAINT pk_liquibase_emp PRIMARY KEY (empid);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT margin_calc_override_ck1 CHECK (valid_from = aws_oracle_ext.TRUNC(valid_from));



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT margin_calc_override_ck2 CHECK (valid_to = aws_oracle_ext.TRUNC(valid_to));



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT margin_calc_override_ck3 CHECK (valid_to >= valid_from);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT margin_calc_override_ck4 CHECK (target_field = TRIM(UPPER(target_field)));



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT margin_calc_override_ck5 CHECK (exclusion_code IN ('T', 'F'));



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT margin_calc_override_pk PRIMARY KEY (broker_asset_id, account_id, target_field, valid_from);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT margin_calc_override_uk UNIQUE (broker_asset_id, account_id, target_field, valid_to);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT sys_c0063126 CHECK (target_value IS NOT NULL);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT sys_c0063127 CHECK (valid_from IS NOT NULL);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT sys_c0063128 CHECK (valid_to IS NOT NULL);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT sys_c0063129 CHECK (when_entered IS NOT NULL);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT sys_c0063130 CHECK (last_updated IS NOT NULL);



ALTER TABLE orcl.margin_calc_override
ADD CONSTRAINT sys_c0063131 CHECK (created_by IS NOT NULL);



ALTER TABLE orcl.merge_jobs
ADD CONSTRAINT pk_merge_jobs PRIMARY KEY (merge_job_id);



ALTER TABLE orcl.observations
ADD CONSTRAINT pk_observations PRIMARY KEY (observation_id);



ALTER TABLE orcl.observations_dummy
ADD CONSTRAINT pk_observations_dummy PRIMARY KEY (observation_id);



ALTER TABLE orcl.outlier_type_detail
ADD PRIMARY KEY (detail_id);



ALTER TABLE orcl.p1_report_parameters
ADD CONSTRAINT p1_report_parameters_pk PRIMARY KEY (report_parameter_id);



ALTER TABLE orcl.partition_group
ADD CONSTRAINT pk_pgroup PRIMARY KEY (group_name, system_name, table_name);



ALTER TABLE orcl.partition_switch
ADD CONSTRAINT pk_pswitch PRIMARY KEY (group_name);



ALTER TABLE orcl.periods
ADD CONSTRAINT pk_periods PRIMARY KEY (period_id);



ALTER TABLE orcl.profit_center_flat_hierarchy
ADD CONSTRAINT pk_profit_center_flat_hier PRIMARY KEY (profit_center_code);



ALTER TABLE orcl.qr_disbursement_samples
ADD CONSTRAINT pk_qr_disbursement_samples PRIMARY KEY (disbursement_sample_id);



ALTER TABLE orcl.qr_te_samples
ADD CONSTRAINT pk_qr_te_samples PRIMARY KEY (te_sample_id);



ALTER TABLE orcl.quarterly_reviews
ADD CONSTRAINT pk_quarterly_reviews PRIMARY KEY (quarterly_review_id);



ALTER TABLE orcl.rise_field_sales_escalations
ADD CONSTRAINT pk_rise_fs_escalations PRIMARY KEY (escalation_number);



ALTER TABLE orcl.rise_investigations
ADD CONSTRAINT pk_rise_investigations PRIMARY KEY (rise_investigation_number);



ALTER TABLE orcl.rise_speaker_non_compliances
ADD CONSTRAINT pk_rise_spkr_non_compliances PRIMARY KEY (non_compliance_id);



ALTER TABLE orcl.roles
ADD CONSTRAINT pk_roles PRIMARY KEY (role_code);



ALTER TABLE orcl.rule_type
ADD PRIMARY KEY (rule_type_id);



ALTER TABLE orcl.tbl_constraint
ADD CONSTRAINT salary_unique_constraint UNIQUE (salary);



ALTER TABLE orcl.tbl_constraint
ADD CONSTRAINT tbl_unique_constraint UNIQUE (id, name);



ALTER TABLE orcl.te_spend_metrics
ADD CONSTRAINT pk_te_spend_metrics PRIMARY KEY (metric_number);



ALTER TABLE orcl.territories
ADD CONSTRAINT pk_territories PRIMARY KEY (territory_code);



ALTER TABLE orcl.therapeutic_areas
ADD CONSTRAINT pk_therapeutic_areas PRIMARY KEY (therapeutic_area_code);



ALTER TABLE orcl.users
ADD CONSTRAINT pk_users PRIMARY KEY (user_id);



